import java.math.BigInteger;
public class DenombrementDamier {
    private int size = 8;
    private TourBlanche tourB1 = new TourBlanche(1, 1);
    private TourBlanche tourB2 = new TourBlanche(2, 2);
    private TourBlanche tourB3 = new TourBlanche(3, 3);
    private TourBlanche tourB4 = new TourBlanche(4, 4);
    private TourNoire tourN1 = new TourNoire(5, 5);
    private TourNoire tourN2 = new TourNoire(6, 6);
    private TourNoire tourN3 = new TourNoire(7, 7);
    private TourNoire tourN4 = new TourNoire(8, 8);
    private BigInteger resultat = new BigInteger("0");
    
    private void incrementTour(Tour tour){
        BigInteger oldResultat = resultat;
        if( positionsCorrectes()){
            resultat = resultat.add(BigInteger.ONE);
        }
        
        tour.increment(size);
        
       /* if(!oldResultat.equals(resultat) && resultat.remainder(new BigInteger("10000")).equals(BigInteger.ZERO)){
            System.out.println("resultat intermédiaire : " + resultat);
        }*/
    }
  

    private void resultat(){
        tourB1.reinit();
        while(tourB1.nombreDeplacement < size*size){
                System.out.println("nombre de déplacement de B1 : " + tourB1.nombreDeplacement);
                tourB2.reinit();
                while(tourB2.nombreDeplacement < size*size){
                       System.out.println("nombre de déplacement de B2 : " + tourB2.nombreDeplacement);
                       tourB3.reinit();
                        while(tourB3.nombreDeplacement < size*size){
                           System.out.println("nombre de déplacement de B3 : " + tourB3.nombreDeplacement);
                            tourB4.reinit();
                            while(tourB4.nombreDeplacement < size*size){
                                System.out.println("nombre de déplacement de B4 : " + tourB4.nombreDeplacement);                                
                                tourN1.reinit();
                                while(tourN1.nombreDeplacement < size*size){
                                        tourN2.reinit();
                                        while(tourN2.nombreDeplacement < size*size){
                                            tourN3.reinit();
                                            while(tourN3.nombreDeplacement < size*size){
                                                tourN4.reinit();
                                                while(tourN4.nombreDeplacement < size*size){
                                                        incrementTour(tourN4);
                                                }    
                                                incrementTour(tourN3);
                                            }    
                                            incrementTour(tourN2);
                                        }    
                                        incrementTour(tourN1);
                                    }
                                    incrementTour(tourB4);
                            }    
                            incrementTour(tourB3);
                       }
                       incrementTour(tourB2);
                }
                incrementTour(tourB1);
        }
    }
    
    private boolean positionSuperpose(Tour tour){
        // tour blanche
        if(tour != tourB1 && tourB1.x == tour.x && tourB1.y == tour.y){
            return true;
        }
        if(tour != tourB2 && tourB2.x == tour.x && tourB2.y == tour.y){
            return true;
        }    
        if(tour != tourB3 && tourB3.x == tour.x && tourB3.y == tour.y){
            return true;
        }
        if(tour != tourB4 && tourB4.x == tour.x && tourB4.y == tour.y){
            return true;
        }    
        // tour noire
        if(tour != tourN1 && tourN1.x == tour.x && tourN1.y == tour.y){
            return true;
        }
        if(tour != tourN2 && tourN2.x == tour.x && tourN2.y == tour.y){
            return true;
        }    
        if(tour != tourN3 && tourN3.x == tour.x && tourN3.y == tour.y){
            return true;
        }
        if(tour != tourN4 && tourN4.x == tour.x && tourN4.y == tour.y){
            return true;
        }
        
        return false;
    }
    private boolean positionsCorrectes(){
        if(positionCorrecte(tourB1)){
            return false;
        }
        if(positionCorrecte(tourB2)){
            return false;
        }
        if(positionCorrecte(tourB3)){
            return false;
        }
        if(positionCorrecte(tourB4)){
            return false;
        }
        if(positionCorrecte(tourN1)){
            return false;
        }
        if(positionCorrecte(tourN2)){
            return false;
        }
        if(positionCorrecte(tourN3)){
            return false;
        }
        if(positionCorrecte(tourN4)){
            return false;
        }
        
        return true;
    }
    
    private boolean positionCorrecte(TourBlanche tourB){
        if(positionSuperpose(tourB)){
            return false;
        }
        if(tourB1 != tourB && (tourB1.x == tourB.x || tourB1.y == tourB.y)){
            return false;
        }
        if(tourB2 != tourB && (tourB2.x == tourB.x || tourB2.y == tourB.y)){
            return false;
        }    
        if(tourB3 != tourB && (tourB3.x == tourB.x || tourB3.y == tourB.y)){
            return false;
        }
        if(tourB4 != tourB && (tourB4.x == tourB.x || tourB4.y == tourB.y)){
            return false;
        }
        
        return true;
    }
    
    private boolean positionCorrecte(TourNoire tourN){
        if(positionSuperpose(tourN)){
            return false;
        }
        if(tourN1 != tourN && (tourN1.x == tourN.x || tourN1.y == tourN.y)){
            return false;
        }
        if(tourN2 != tourN && (tourN2.x == tourN.x || tourN2.y == tourN.y)){
            return false;
        }    
        if(tourN3 != tourN && (tourN3.x == tourN.x || tourN3.y == tourN.y)){
            return false;
        }
        if(tourN4 != tourN && (tourN4.x == tourN.x || tourN4.y == tourN.y)){
            return false;
        }
        
        return true;    
    }
    
    public static void main(String[] args){
        DenombrementDamier d = new DenombrementDamier();
        d.resultat();
        System.out.println("Nombre de combinaisons : " + d.resultat);
    }
}
